/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.323 Revision 1.363
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.323 2009/12/19 00:01:04 zmedico Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.363 2011/09/12 20:44:01 mgorny Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
17 17
18inherit multilib portability 18inherit multilib portability
19 19
20DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
21 21
22if has "${EAPI:-0}" 0 1 2; then
23
22# @FUNCTION: epause 24# @FUNCTION: epause
23# @USAGE: [seconds] 25# @USAGE: [seconds]
24# @DESCRIPTION: 26# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 28# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 30# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 31epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 33}
32 34
33# @FUNCTION: ebeep 35# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 36# @USAGE: [number of beeps]
35# @DESCRIPTION: 37# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 38# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 39# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 41# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 42ebeep() {
41 local n 43 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 46 echo -ne "\a"
47 sleep 1 49 sleep 1
48 done 50 done
49 fi 51 fi
50} 52}
51 53
54else
55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 }
76fi
77
52# @FUNCTION: ecvs_clean 78# @FUNCTION: ecvs_clean
53# @USAGE: [list of dirs] 79# @USAGE: [list of dirs]
54# @DESCRIPTION: 80# @DESCRIPTION:
55# Remove CVS directories recursiveley. Useful when a source tarball contains 81# Remove CVS directories recursiveley. Useful when a source tarball contains
56# internal CVS directories. Defaults to $PWD. 82# internal CVS directories. Defaults to $PWD.
69 [[ -z $* ]] && set -- . 95 [[ -z $* ]] && set -- .
70 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf 96 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
71} 97}
72 98
73# @FUNCTION: eshopts_push 99# @FUNCTION: eshopts_push
74# @USAGE: [options to `set`] 100# @USAGE: [options to `set` or `shopt`]
75# @DESCRIPTION: 101# @DESCRIPTION:
76# Often times code will want to enable a shell option to change code behavior. 102# Often times code will want to enable a shell option to change code behavior.
77# Since changing shell options can easily break other pieces of code (which 103# Since changing shell options can easily break other pieces of code (which
78# assume the default state), eshopts_push is used to (1) push the current shell 104# assume the default state), eshopts_push is used to (1) push the current shell
79# options onto a stack and (2) pass the specified arguments to set. 105# options onto a stack and (2) pass the specified arguments to set.
106#
107# If the first argument is '-s' or '-u', we assume you want to call `shopt`
108# rather than `set` as there are some options only available via that.
80# 109#
81# A common example is to disable shell globbing so that special meaning/care 110# A common example is to disable shell globbing so that special meaning/care
82# may be used with variables/arguments to custom functions. That would be: 111# may be used with variables/arguments to custom functions. That would be:
83# @CODE 112# @CODE
84# eshopts_push -o noglob 113# eshopts_push -o noglob
92# @CODE 121# @CODE
93eshopts_push() { 122eshopts_push() {
94 # have to assume __ESHOPTS_SAVE__ isn't screwed with 123 # have to assume __ESHOPTS_SAVE__ isn't screwed with
95 # as a `declare -a` here will reset its value 124 # as a `declare -a` here will reset its value
96 local i=${#__ESHOPTS_SAVE__[@]} 125 local i=${#__ESHOPTS_SAVE__[@]}
126 if [[ $1 == -[su] ]] ; then
97 __ESHOPTS_SAVE__[$i]=$- 127 __ESHOPTS_SAVE__[$i]=$(shopt -p)
98 [[ $# -eq 0 ]] && return 0 128 [[ $# -eq 0 ]] && return 0
129 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
130 else
131 __ESHOPTS_SAVE__[$i]=$-
132 [[ $# -eq 0 ]] && return 0
99 set "$@" || die "eshopts_push: bad options to set: $*" 133 set "$@" || die "eshopts_push: bad options to set: $*"
134 fi
100} 135}
101 136
102# @FUNCTION: eshopts_pop 137# @FUNCTION: eshopts_pop
103# @USAGE: 138# @USAGE:
104# @DESCRIPTION: 139# @DESCRIPTION:
108 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments" 143 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
109 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 )) 144 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
110 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair" 145 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
111 local s=${__ESHOPTS_SAVE__[$i]} 146 local s=${__ESHOPTS_SAVE__[$i]}
112 unset __ESHOPTS_SAVE__[$i] 147 unset __ESHOPTS_SAVE__[$i]
148 if [[ ${s} == "shopt -"* ]] ; then
149 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
150 else
113 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-" 151 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
114 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}" 152 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
153 fi
115} 154}
116 155
117# Default directory where patches are located 156# @VARIABLE: EPATCH_SOURCE
157# @DESCRIPTION:
158# Default directory to search for patches.
118EPATCH_SOURCE="${WORKDIR}/patch" 159EPATCH_SOURCE="${WORKDIR}/patch"
119# Default extension for patches 160# @VARIABLE: EPATCH_SUFFIX
161# @DESCRIPTION:
162# Default extension for patches (do not prefix the period yourself).
120EPATCH_SUFFIX="patch.bz2" 163EPATCH_SUFFIX="patch.bz2"
164# @VARIABLE: EPATCH_OPTS
165# @DESCRIPTION:
121# Default options for patch 166# Default options for patch:
167# @CODE
122# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 168# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
123# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 169# --no-backup-if-mismatch - do not leave .orig files behind
124# Set -E to automatically remove empty files. 170# -E - automatically remove empty files
171# @CODE
125EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 172EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
173# @VARIABLE: EPATCH_EXCLUDE
174# @DESCRIPTION:
126# List of patches not to apply. Note this is only file names, 175# List of patches not to apply. Note this is only file names,
127# and not the full path .. 176# and not the full path. Globs accepted.
128EPATCH_EXCLUDE="" 177EPATCH_EXCLUDE=""
178# @VARIABLE: EPATCH_SINGLE_MSG
179# @DESCRIPTION:
129# Change the printed message for a single patch. 180# Change the printed message for a single patch.
130EPATCH_SINGLE_MSG="" 181EPATCH_SINGLE_MSG=""
182# @VARIABLE: EPATCH_MULTI_MSG
183# @DESCRIPTION:
131# Change the printed message for multiple patches. 184# Change the printed message for multiple patches.
132EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 185EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
133# Force applying bulk patches even if not following the style: 186# @VARIABLE: EPATCH_FORCE
134# 187# @DESCRIPTION:
135# ??_${ARCH}_foo.${EPATCH_SUFFIX} 188# Only require patches to match EPATCH_SUFFIX rather than the extended
136# 189# arch naming style.
137EPATCH_FORCE="no" 190EPATCH_FORCE="no"
138 191
139# This function is for bulk patching, or in theory for just one 192# @FUNCTION: epatch
140# or two patches. 193# @USAGE: [patches] [dirs of patches]
194# @DESCRIPTION:
195# epatch is designed to greatly simplify the application of patches. It can
196# process patch files directly, or directories of patches. The patches may be
197# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
198# the -p option as epatch will automatically attempt -p0 to -p5 until things
199# apply successfully.
141# 200#
142# It should work with .bz2, .gz, .zip and plain text patches. 201# If you do not specify any options, then epatch will default to the directory
143# Currently all patches should be the same format. 202# specified by EPATCH_SOURCE.
144# 203#
145# You do not have to specify '-p' option to patch, as it will 204# When processing directories, epatch will apply all patches that match:
146# try with -p0 to -p5 until it succeed, or fail at -p5. 205# @CODE
147# 206# if ${EPATCH_FORCE} != "yes"
148# Above EPATCH_* variables can be used to control various defaults,
149# bug they should be left as is to ensure an ebuild can rely on
150# them for.
151#
152# Patches are applied in current directory.
153#
154# Bulk Patches should preferably have the form of:
155#
156# ??_${ARCH}_foo.${EPATCH_SUFFIX} 207# ??_${ARCH}_foo.${EPATCH_SUFFIX}
208# else
209# *.${EPATCH_SUFFIX}
210# @CODE
211# The leading ?? are typically numbers used to force consistent patch ordering.
212# The arch field is used to apply patches only for the host architecture with
213# the special value of "all" means apply for everyone. Note that using values
214# other than "all" is highly discouraged -- you should apply patches all the
215# time and let architecture details be detected at configure/compile time.
157# 216#
158# For example: 217# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
218# for patches to apply.
159# 219#
160# 01_all_misc-fix.patch.bz2 220# Refer to the other EPATCH_xxx variables for more customization of behavior.
161# 02_sparc_another-fix.patch.bz2
162#
163# This ensures that there are a set order, and you can have ARCH
164# specific patches.
165#
166# If you however give an argument to epatch(), it will treat it as a
167# single patch that need to be applied if its a file. If on the other
168# hand its a directory, it will set EPATCH_SOURCE to this.
169#
170# <azarah@gentoo.org> (10 Nov 2002)
171#
172epatch() { 221epatch() {
173 _epatch_draw_line() { 222 _epatch_draw_line() {
223 # create a line of same length as input string
174 [[ -z $1 ]] && set "$(printf "%65s" '')" 224 [[ -z $1 ]] && set "$(printf "%65s" '')"
175 echo "${1//?/=}" 225 echo "${1//?/=}"
176 } 226 }
177 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
178 local PIPE_CMD=""
179 local STDERR_TARGET="${T}/$$.out"
180 local PATCH_TARGET="${T}/$$.patch"
181 local PATCH_SUFFIX=""
182 local SINGLE_PATCH="no"
183 local x=""
184 227
185 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 228 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
186 229
187 if [ "$#" -gt 1 ] 230 # Let the rest of the code process one user arg at a time --
188 then 231 # each arg may expand into multiple patches, and each arg may
232 # need to start off with the default global EPATCH_xxx values
233 if [[ $# -gt 1 ]] ; then
189 local m="" 234 local m
190 for m in "$@" ; do 235 for m in "$@" ; do
191 epatch "${m}" 236 epatch "${m}"
192 done 237 done
193 return 0 238 return 0
194 fi 239 fi
195 240
196 if [ -n "$1" -a -f "$1" ] 241 local SINGLE_PATCH="no"
197 then 242 # no args means process ${EPATCH_SOURCE}
243 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
244
245 if [[ -f $1 ]] ; then
198 SINGLE_PATCH="yes" 246 SINGLE_PATCH="yes"
199 247 set -- "$1"
200 local EPATCH_SOURCE="$1" 248 # Use the suffix from the single patch (localize it); the code
249 # below will find the suffix for us
201 local EPATCH_SUFFIX="${1##*\.}" 250 local EPATCH_SUFFIX=$1
202 251
203 elif [ -n "$1" -a -d "$1" ] 252 elif [[ -d $1 ]] ; then
204 then 253 # Some people like to make dirs of patches w/out suffixes (vim)
205 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 254 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
206 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 255
256 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
257 # Re-use EPATCH_SOURCE as a search dir
258 epatch "${EPATCH_SOURCE}/$1"
259 return $?
260
261 else
262 # sanity check ... if it isn't a dir or file, wtf man ?
263 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
264 echo
265 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
266 eerror
267 eerror " ${EPATCH_SOURCE}"
268 eerror " ( ${EPATCH_SOURCE##*/} )"
269 echo
270 die "Cannot find \$EPATCH_SOURCE!"
271 fi
272
273 local PIPE_CMD
274 case ${EPATCH_SUFFIX##*\.} in
275 xz) PIPE_CMD="xz -dc" ;;
276 lzma) PIPE_CMD="lzma -dc" ;;
277 bz2) PIPE_CMD="bzip2 -dc" ;;
278 gz|Z|z) PIPE_CMD="gzip -dc" ;;
279 ZIP|zip) PIPE_CMD="unzip -p" ;;
280 *) ;;
281 esac
282
283 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
284
285 local x
286 for x in "$@" ; do
287 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
288 # didn't match anything, ignore continue on
289 [[ ! -f ${x} ]] && continue
290
291 local patchname=${x##*/}
292
293 # Apply single patches, or forced sets of patches, or
294 # patches with ARCH dependant names.
295 # ???_arch_foo.patch
296 # Else, skip this input altogether
297 local a=${patchname#*_} # strip the ???_
298 a=${a%%_*} # strip the _foo.patch
299 if ! [[ ${SINGLE_PATCH} == "yes" || \
300 ${EPATCH_FORCE} == "yes" || \
301 ${a} == all || \
302 ${a} == ${ARCH} ]]
207 then 303 then
208 local EPATCH_SOURCE="$1/*" 304 continue
305 fi
306
307 # Let people filter things dynamically
308 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
309 # let people use globs in the exclude
310 eshopts_push -o noglob
311
312 local ex
313 for ex in ${EPATCH_EXCLUDE} ; do
314 if [[ ${patchname} == ${ex} ]] ; then
315 eshopts_pop
316 continue 2
317 fi
318 done
319
320 eshopts_pop
321 fi
322
323 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
324 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
325 einfo "${EPATCH_SINGLE_MSG}"
326 else
327 einfo "Applying ${patchname} ..."
328 fi
209 else 329 else
210 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 330 einfo " ${patchname} ..."
211 fi 331 fi
212 else 332
213 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 333 # most of the time, there will only be one run per unique name,
214 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 334 # but if there are more, make sure we get unique log filenames
215 then 335 local STDERR_TARGET="${T}/${patchname}.out"
216 EPATCH_SOURCE="$1" 336 if [[ -e ${STDERR_TARGET} ]] ; then
337 STDERR_TARGET="${T}/${patchname}-$$.out"
338 fi
339
340 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
341
342 # Decompress the patch if need be
343 local count=0
344 local PATCH_TARGET
345 if [[ -n ${PIPE_CMD} ]] ; then
346 PATCH_TARGET="${T}/$$.patch"
347 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
348
349 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
350 echo
351 eerror "Could not extract patch!"
352 #die "Could not extract patch!"
353 count=5
354 break
217 fi 355 fi
356 else
357 PATCH_TARGET=${x}
358 fi
218 359
360 # Check for absolute paths in patches. If sandbox is disabled,
361 # people could (accidently) patch files in the root filesystem.
362 # Or trigger other unpleasantries #237667. So disallow -p0 on
363 # such patches.
364 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
365 if [[ -n ${abs_paths} ]] ; then
366 count=1
367 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
368 fi
369 # Similar reason, but with relative paths.
370 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
371 if [[ -n ${rel_paths} ]] ; then
372 eqawarn "QA Notice: Your patch uses relative paths '../'."
373 eqawarn " In the future this will cause a failure."
374 eqawarn "${rel_paths}"
375 fi
376
377 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
378 while [[ ${count} -lt 5 ]] ; do
379 # Generate some useful debug info ...
380 (
381 _epatch_draw_line "***** ${patchname} *****"
219 echo 382 echo
220 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 383 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
384 echo
385 _epatch_draw_line "***** ${patchname} *****"
386 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
387 ret=$?
388 echo
389 echo "patch program exited with status ${ret}"
390 exit ${ret}
391 ) >> "${STDERR_TARGET}"
392
393 if [ $? -eq 0 ] ; then
394 (
395 _epatch_draw_line "***** ${patchname} *****"
396 echo
397 echo "ACTUALLY APPLYING ${patchname} ..."
398 echo
399 _epatch_draw_line "***** ${patchname} *****"
400 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
401 ret=$?
402 echo
403 echo "patch program exited with status ${ret}"
404 exit ${ret}
405 ) >> "${STDERR_TARGET}"
406
407 if [ $? -ne 0 ] ; then
408 echo
409 eerror "A dry-run of patch command succeeded, but actually"
410 eerror "applying the patch failed!"
411 #die "Real world sux compared to the dreamworld!"
412 count=5
413 fi
414 break
415 fi
416
417 : $(( count++ ))
418 done
419
420 # if we had to decompress the patch, delete the temp one
421 if [[ -n ${PIPE_CMD} ]] ; then
422 rm -f "${PATCH_TARGET}"
423 fi
424
425 if [[ ${count} -ge 5 ]] ; then
426 echo
427 eerror "Failed Patch: ${patchname} !"
428 eerror " ( ${PATCH_TARGET} )"
221 eerror 429 eerror
222 eerror " ${EPATCH_SOURCE}" 430 eerror "Include in your bugreport the contents of:"
223 eerror " ( ${EPATCH_SOURCE##*/} )" 431 eerror
432 eerror " ${STDERR_TARGET}"
224 echo 433 echo
225 die "Cannot find \$EPATCH_SOURCE!"
226 fi
227
228 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
229 fi
230
231 case ${EPATCH_SUFFIX##*\.} in
232 xz)
233 PIPE_CMD="xz -dc"
234 PATCH_SUFFIX="xz"
235 ;;
236 lzma)
237 PIPE_CMD="lzma -dc"
238 PATCH_SUFFIX="lzma"
239 ;;
240 bz2)
241 PIPE_CMD="bzip2 -dc"
242 PATCH_SUFFIX="bz2"
243 ;;
244 gz|Z|z)
245 PIPE_CMD="gzip -dc"
246 PATCH_SUFFIX="gz"
247 ;;
248 ZIP|zip)
249 PIPE_CMD="unzip -p"
250 PATCH_SUFFIX="zip"
251 ;;
252 *)
253 PIPE_CMD="cat"
254 PATCH_SUFFIX="patch"
255 ;;
256 esac
257
258 if [ "${SINGLE_PATCH}" = "no" ]
259 then
260 einfo "${EPATCH_MULTI_MSG}"
261 fi
262 for x in ${EPATCH_SOURCE}
263 do
264 # New ARCH dependant patch naming scheme ...
265 #
266 # ???_arch_foo.patch
267 #
268 if [ -f ${x} ] && \
269 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
270 [ "${EPATCH_FORCE}" = "yes" ])
271 then
272 local count=0
273 local popts="${EPATCH_OPTS}"
274 local patchname=${x##*/}
275
276 if [ -n "${EPATCH_EXCLUDE}" ]
277 then
278 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
279 then
280 continue
281 fi
282 fi
283
284 if [ "${SINGLE_PATCH}" = "yes" ]
285 then
286 if [ -n "${EPATCH_SINGLE_MSG}" ]
287 then
288 einfo "${EPATCH_SINGLE_MSG}"
289 else
290 einfo "Applying ${patchname} ..."
291 fi
292 else
293 einfo " ${patchname} ..."
294 fi
295
296 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
297 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
298
299 # Decompress the patch if need be
300 if [[ ${PATCH_SUFFIX} != "patch" ]] ; then
301 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
302 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
303
304 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 ; then
305 echo
306 eerror "Could not extract patch!"
307 #die "Could not extract patch!"
308 count=5
309 break
310 fi
311 else
312 PATCH_TARGET="${x}"
313 fi
314
315 # Check for absolute paths in patches. If sandbox is disabled,
316 # people could (accidently) patch files in the root filesystem.
317 # Or trigger other unpleasantries #237667. So disallow -p0 on
318 # such patches.
319 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
320 if [[ -n ${abs_paths} ]] ; then
321 count=1
322 echo "NOTE: skipping -p0 due to absolute paths in patch:" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
323 echo "${abs_paths}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
324 fi
325
326 # Allow for prefix to differ ... im lazy, so shoot me :/
327 while [ "${count}" -lt 5 ]
328 do
329 # Generate some useful debug info ...
330 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
331 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
332
333 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
334 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
335
336 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
337 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
338
339 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
340 then
341 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
342 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
343 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
344 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
345 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
346
347 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
348 _epatch_assert
349
350 if [ "$?" -ne 0 ]
351 then
352 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
353 echo
354 eerror "A dry-run of patch command succeeded, but actually"
355 eerror "applying the patch failed!"
356 #die "Real world sux compared to the dreamworld!"
357 count=5
358 fi
359
360 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
361
362 break
363 fi
364
365 count=$((count + 1))
366 done
367
368 if [ "${PATCH_SUFFIX}" != "patch" ]
369 then
370 rm -f ${PATCH_TARGET}
371 fi
372
373 if [ "${count}" -eq 5 ]
374 then
375 echo
376 eerror "Failed Patch: ${patchname} !"
377 eerror " ( ${PATCH_TARGET} )"
378 eerror
379 eerror "Include in your bugreport the contents of:"
380 eerror
381 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
382 echo
383 die "Failed Patch: ${patchname}!" 434 die "Failed Patch: ${patchname}!"
384 fi 435 fi
385 436
386 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 437 # if everything worked, delete the patch log
387 438 rm -f "${STDERR_TARGET}"
388 eend 0 439 eend 0
389 fi
390 done 440 done
391 if [ "${SINGLE_PATCH}" = "no" ] 441
392 then 442 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
393 einfo "Done with patching" 443 : # everything worked
394 fi
395} 444}
445
446# @FUNCTION: epatch_user
447# @USAGE:
448# @DESCRIPTION:
449# Applies user-provided patches to the source tree. The patches are
450# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
451# of these three directories to exist will be the one to use, ignoring
452# any more general directories which might exist as well.
453#
454# User patches are intended for quick testing of patches without ebuild
455# modifications, as well as for permanent customizations a user might
456# desire. Obviously, there can be no official support for arbitrarily
457# patched ebuilds. So whenever a build log in a bug report mentions that
458# user patches were applied, the user should be asked to reproduce the
459# problem without these.
460#
461# Not all ebuilds do call this function, so placing patches in the
462# stated directory might or might not work, depending on the package and
463# the eclasses it inherits and uses. It is safe to call the function
464# repeatedly, so it is always possible to add a call at the ebuild
465# level. The first call is the time when the patches will be
466# applied.
467#
468# Ideally, this function should be called after gentoo-specific patches
469# have been applied, so that their code can be modified as well, but
470# before calls to e.g. eautoreconf, as the user patches might affect
471# autotool input files as well.
396epatch_user() { 472epatch_user() {
397 [[ $# -ne 0 ]] && die "epatch_user takes no options" 473 [[ $# -ne 0 ]] && die "epatch_user takes no options"
474
475 # Allow multiple calls to this function; ignore all but the first
476 local applied="${T}/epatch_user.applied"
477 [[ -e ${applied} ]] && return 2
398 478
399 # don't clobber any EPATCH vars that the parent might want 479 # don't clobber any EPATCH vars that the parent might want
400 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches 480 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
401 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do 481 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
402 EPATCH_SOURCE=${base}/${CTARGET}/${check} 482 EPATCH_SOURCE=${base}/${CTARGET}/${check}
406 EPATCH_SOURCE=${EPATCH_SOURCE} \ 486 EPATCH_SOURCE=${EPATCH_SOURCE} \
407 EPATCH_SUFFIX="patch" \ 487 EPATCH_SUFFIX="patch" \
408 EPATCH_FORCE="yes" \ 488 EPATCH_FORCE="yes" \
409 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \ 489 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
410 epatch 490 epatch
411 break 491 echo "${EPATCH_SOURCE}" > "${applied}"
492 return 0
412 fi 493 fi
413 done 494 done
495 echo "none" > "${applied}"
496 return 1
414} 497}
415 498
416# @FUNCTION: emktemp 499# @FUNCTION: emktemp
417# @USAGE: [temp dir] 500# @USAGE: [temp dir]
418# @DESCRIPTION: 501# @DESCRIPTION:
462egetent() { 545egetent() {
463 case ${CHOST} in 546 case ${CHOST} in
464 *-darwin[678]) 547 *-darwin[678])
465 case "$2" in 548 case "$2" in
466 *[!0-9]*) # Non numeric 549 *[!0-9]*) # Non numeric
467 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 550 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2\$/) {print \$0;exit;} }"
468 ;; 551 ;;
469 *) # Numeric 552 *) # Numeric
470 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 553 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
471 ;; 554 ;;
472 esac 555 esac
690 fi 773 fi
691 ;; 774 ;;
692 775
693 *) 776 *)
694 if [[ -z $@ ]] ; then 777 if [[ -z $@ ]] ; then
695 useradd ${opts} \ 778 useradd -r ${opts} \
696 -c "added by portage for ${PN}" \ 779 -c "added by portage for ${PN}" \
697 ${euser} \ 780 ${euser} \
698 || die "enewuser failed" 781 || die "enewuser failed"
699 else 782 else
700 einfo " - Extra: $@" 783 einfo " - Extra: $@"
701 useradd ${opts} "$@" \ 784 useradd -r ${opts} "$@" \
702 ${euser} \ 785 ${euser} \
703 || die "enewuser failed" 786 || die "enewuser failed"
704 fi 787 fi
705 ;; 788 ;;
706 esac 789 esac
819 esac 902 esac
820 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 903 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
821 ;; 904 ;;
822 905
823 *) 906 *)
907 # We specify -r so that we get a GID in the system range from login.defs
824 groupadd ${opts} ${egroup} || die "enewgroup failed" 908 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
825 ;; 909 ;;
826 esac 910 esac
827 export SANDBOX_ON="${oldsandbox}" 911 export SANDBOX_ON="${oldsandbox}"
828} 912}
829 913
840 924
841# Make a desktop file ! 925# Make a desktop file !
842# Great for making those icons in kde/gnome startmenu ! 926# Great for making those icons in kde/gnome startmenu !
843# Amaze your friends ! Get the women ! Join today ! 927# Amaze your friends ! Get the women ! Join today !
844# 928#
845# make_desktop_entry(<command>, [name], [icon], [type], [path]) 929# make_desktop_entry(<command>, [name], [icon], [type], [fields])
846# 930#
847# binary: what command does the app run with ? 931# binary: what command does the app run with ?
848# name: the name that will show up in the menu 932# name: the name that will show up in the menu
849# icon: give your little like a pretty little icon ... 933# icon: give your little like a pretty little icon ...
850# this can be relative (to /usr/share/pixmaps) or 934# this can be relative (to /usr/share/pixmaps) or
851# a full path to an icon 935# a full path to an icon
852# type: what kind of application is this ? for categories: 936# type: what kind of application is this ? for categories:
853# http://standards.freedesktop.org/menu-spec/latest/apa.html 937# http://standards.freedesktop.org/menu-spec/latest/apa.html
854# path: if your app needs to startup in a specific dir 938# fields: extra fields to append to the desktop file; a printf string
855make_desktop_entry() { 939make_desktop_entry() {
856 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 940 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
857 941
858 local exec=${1} 942 local exec=${1}
859 local name=${2:-${PN}} 943 local name=${2:-${PN}}
860 local icon=${3:-${PN}} 944 local icon=${3:-${PN}}
861 local type=${4} 945 local type=${4}
862 local path=${5} 946 local fields=${5}
863 947
864 if [[ -z ${type} ]] ; then 948 if [[ -z ${type} ]] ; then
865 local catmaj=${CATEGORY%%-*} 949 local catmaj=${CATEGORY%%-*}
866 local catmin=${CATEGORY##*-} 950 local catmin=${CATEGORY##*-}
867 case ${catmaj} in 951 case ${catmaj} in
868 app) 952 app)
869 case ${catmin} in 953 case ${catmin} in
870 accessibility) type=Accessibility;; 954 accessibility) type=Accessibility;;
871 admin) type=System;; 955 admin) type=System;;
872 antivirus) type=System;; 956 antivirus) type=System;;
873 arch) type=Archiving;; 957 arch) type=Archiving;;
874 backup) type=Archiving;; 958 backup) type=Archiving;;
875 cdr) type=DiscBurning;; 959 cdr) type=DiscBurning;;
876 dicts) type=Dictionary;; 960 dicts) type=Dictionary;;
877 doc) type=Documentation;; 961 doc) type=Documentation;;
878 editors) type=TextEditor;; 962 editors) type=TextEditor;;
879 emacs) type=TextEditor;; 963 emacs) type=TextEditor;;
880 emulation) type=Emulator;; 964 emulation) type=Emulator;;
881 laptop) type=HardwareSettings;; 965 laptop) type=HardwareSettings;;
882 office) type=Office;; 966 office) type=Office;;
883 pda) type=PDA;; 967 pda) type=PDA;;
884 vim) type=TextEditor;; 968 vim) type=TextEditor;;
885 xemacs) type=TextEditor;; 969 xemacs) type=TextEditor;;
886 *) type=;;
887 esac 970 esac
888 ;; 971 ;;
889 972
890 dev) 973 dev)
891 type="Development" 974 type="Development"
892 ;; 975 ;;
893 976
894 games) 977 games)
895 case ${catmin} in 978 case ${catmin} in
896 action|fps) type=ActionGame;; 979 action|fps) type=ActionGame;;
897 arcade) type=ArcadeGame;; 980 arcade) type=ArcadeGame;;
898 board) type=BoardGame;; 981 board) type=BoardGame;;
899 emulation) type=Emulator;; 982 emulation) type=Emulator;;
900 kids) type=KidsGame;; 983 kids) type=KidsGame;;
901 puzzle) type=LogicGame;; 984 puzzle) type=LogicGame;;
902 roguelike) type=RolePlaying;; 985 roguelike) type=RolePlaying;;
903 rpg) type=RolePlaying;; 986 rpg) type=RolePlaying;;
904 simulation) type=Simulation;; 987 simulation) type=Simulation;;
905 sports) type=SportsGame;; 988 sports) type=SportsGame;;
906 strategy) type=StrategyGame;; 989 strategy) type=StrategyGame;;
907 *) type=;;
908 esac 990 esac
909 type="Game;${type}" 991 type="Game;${type}"
910 ;; 992 ;;
911 993
912 gnome) 994 gnome)
921 type="Network;Email" 1003 type="Network;Email"
922 ;; 1004 ;;
923 1005
924 media) 1006 media)
925 case ${catmin} in 1007 case ${catmin} in
1008 gfx)
926 gfx) type=Graphics;; 1009 type=Graphics
1010 ;;
1011 *)
1012 case ${catmin} in
927 radio) type=Tuner;; 1013 radio) type=Tuner;;
928 sound) type=Audio;; 1014 sound) type=Audio;;
929 tv) type=TV;; 1015 tv) type=TV;;
930 video) type=Video;; 1016 video) type=Video;;
931 *) type=;; 1017 esac
1018 type="AudioVideo;${type}"
1019 ;;
932 esac 1020 esac
933 type="AudioVideo;${type}"
934 ;; 1021 ;;
935 1022
936 net) 1023 net)
937 case ${catmin} in 1024 case ${catmin} in
938 dialup) type=Dialup;; 1025 dialup) type=Dialup;;
939 ftp) type=FileTransfer;; 1026 ftp) type=FileTransfer;;
940 im) type=InstantMessaging;; 1027 im) type=InstantMessaging;;
941 irc) type=IRCClient;; 1028 irc) type=IRCClient;;
942 mail) type=Email;; 1029 mail) type=Email;;
943 news) type=News;; 1030 news) type=News;;
944 nntp) type=News;; 1031 nntp) type=News;;
945 p2p) type=FileTransfer;; 1032 p2p) type=FileTransfer;;
946 *) type=;; 1033 voip) type=Telephony;;
947 esac 1034 esac
948 type="Network;${type}" 1035 type="Network;${type}"
949 ;; 1036 ;;
950 1037
951 sci) 1038 sci)
952 case ${catmin} in 1039 case ${catmin} in
953 astro*) type=Astronomy;; 1040 astro*) type=Astronomy;;
954 bio*) type=Biology;; 1041 bio*) type=Biology;;
955 calc*) type=Calculator;; 1042 calc*) type=Calculator;;
956 chem*) type=Chemistry;; 1043 chem*) type=Chemistry;;
957 elec*) type=Electronics;; 1044 elec*) type=Electronics;;
958 geo*) type=Geology;; 1045 geo*) type=Geology;;
959 math*) type=Math;; 1046 math*) type=Math;;
960 physics) type=Physics;; 1047 physics) type=Physics;;
961 visual*) type=DataVisualization;; 1048 visual*) type=DataVisualization;;
962 *) type=;;
963 esac 1049 esac
964 type="Science;${type}" 1050 type="Education;Science;${type}"
965 ;; 1051 ;;
966 1052
967 sys) 1053 sys)
968 type="System" 1054 type="System"
969 ;; 1055 ;;
970 1056
971 www) 1057 www)
972 case ${catmin} in 1058 case ${catmin} in
973 client) type=WebBrowser;; 1059 client) type=WebBrowser;;
974 *) type=;;
975 esac 1060 esac
976 type="Network" 1061 type="Network;${type}"
977 ;; 1062 ;;
978 1063
979 *) 1064 *)
980 type= 1065 type=
981 ;; 1066 ;;
986 else 1071 else
987 local desktop_name="${PN}-${SLOT}" 1072 local desktop_name="${PN}-${SLOT}"
988 fi 1073 fi
989 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 1074 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
990 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1075 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
1076
1077 # Don't append another ";" when a valid category value is provided.
1078 type=${type%;}${type:+;}
1079
1080 eshopts_push -s extglob
1081 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1082 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1083 ewarn "allowed in .desktop files if the value is not an absolute path."
1084 icon=${icon%.@(xpm|png|svg)}
1085 fi
1086 eshopts_pop
991 1087
992 cat <<-EOF > "${desktop}" 1088 cat <<-EOF > "${desktop}"
993 [Desktop Entry] 1089 [Desktop Entry]
994 Name=${name} 1090 Name=${name}
995 Type=Application 1091 Type=Application
996 Comment=${DESCRIPTION} 1092 Comment=${DESCRIPTION}
997 Exec=${exec} 1093 Exec=${exec}
998 TryExec=${exec%% *} 1094 TryExec=${exec%% *}
999 Icon=${icon} 1095 Icon=${icon}
1000 Categories=${type}; 1096 Categories=${type}
1001 EOF 1097 EOF
1002 1098
1003 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 1099 if [[ ${fields:-=} != *=* ]] ; then
1100 # 5th arg used to be value to Path=
1101 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1102 fields="Path=${fields}"
1103 fi
1104 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
1004 1105
1005 ( 1106 (
1006 # wrap the env here so that the 'insinto' call 1107 # wrap the env here so that the 'insinto' call
1007 # doesn't corrupt the env of the caller 1108 # doesn't corrupt the env of the caller
1008 insinto /usr/share/applications 1109 insinto /usr/share/applications
1009 doins "${desktop}" 1110 doins "${desktop}"
1010 ) 1111 ) || die "installing desktop file failed"
1011} 1112}
1012 1113
1013# @FUNCTION: validate_desktop_entries 1114# @FUNCTION: validate_desktop_entries
1014# @USAGE: [directories] 1115# @USAGE: [directories]
1015# @MAINTAINER: 1116# @MAINTAINER:
1294 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1395 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1295 1396
1296 local shrtsrc=$(basename "${src}") 1397 local shrtsrc=$(basename "${src}")
1297 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1398 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1298 if [[ -z ${skip} ]] ; then 1399 if [[ -z ${skip} ]] ; then
1299 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1400 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1300 local skip=0 1401 local skip=0
1301 exe=tail 1402 exe=tail
1302 case ${ver} in 1403 case ${ver} in
1303 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1404 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1304 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1405 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1306 2.0|2.0.1) 1407 2.0|2.0.1)
1307 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1408 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1308 ;; 1409 ;;
1309 2.1.1) 1410 2.1.1)
1310 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1411 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1311 let skip="skip + 1" 1412 (( skip++ ))
1312 ;; 1413 ;;
1313 2.1.2) 1414 2.1.2)
1314 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1415 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1315 let skip="skip + 1" 1416 (( skip++ ))
1316 ;; 1417 ;;
1317 2.1.3) 1418 2.1.3)
1318 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1419 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1319 let skip="skip + 1" 1420 (( skip++ ))
1320 ;; 1421 ;;
1321 2.1.4|2.1.5) 1422 2.1.4|2.1.5)
1322 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1423 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1323 skip=$(head -n ${skip} "${src}" | wc -c) 1424 skip=$(head -n ${skip} "${src}" | wc -c)
1324 exe="dd" 1425 exe="dd"
1333 esac 1434 esac
1334 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1435 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1335 fi 1436 fi
1336 case ${exe} in 1437 case ${exe} in
1337 tail) exe="tail -n +${skip} '${src}'";; 1438 tail) exe="tail -n +${skip} '${src}'";;
1338 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1439 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1339 *) die "makeself cant handle exe '${exe}'" 1440 *) die "makeself cant handle exe '${exe}'"
1340 esac 1441 esac
1341 1442
1342 # lets grab the first few bytes of the file to figure out what kind of archive it is 1443 # lets grab the first few bytes of the file to figure out what kind of archive it is
1343 local tmpfile=$(emktemp) 1444 local filetype tmpfile=$(emktemp)
1344 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1445 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1345 local filetype=$(file -b "${tmpfile}") 1446 filetype=$(file -b "${tmpfile}") || die
1346 case ${filetype} in 1447 case ${filetype} in
1347 *tar\ archive*) 1448 *tar\ archive*)
1348 eval ${exe} | tar --no-same-owner -xf - 1449 eval ${exe} | tar --no-same-owner -xf -
1349 ;; 1450 ;;
1350 bzip2*) 1451 bzip2*)
1380 lic="${PWD}/${lic}" 1481 lic="${PWD}/${lic}"
1381 elif [ -e "${lic}" ] ; then 1482 elif [ -e "${lic}" ] ; then
1382 lic="${lic}" 1483 lic="${lic}"
1383 fi 1484 fi
1384 fi 1485 fi
1385 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1386 local l="`basename ${lic}`" 1486 local l="`basename ${lic}`"
1387 1487
1388 # here is where we check for the licenses the user already 1488 # here is where we check for the licenses the user already
1389 # accepted ... if we don't find a match, we make the user accept 1489 # accepted ... if we don't find a match, we make the user accept
1390 local alic 1490 local alic
1394 eshopts_pop 1494 eshopts_pop
1395 return 0 1495 return 0
1396 fi 1496 fi
1397 done 1497 done
1398 eshopts_pop 1498 eshopts_pop
1499 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1399 1500
1400 local licmsg=$(emktemp) 1501 local licmsg=$(emktemp)
1401 cat <<-EOF > ${licmsg} 1502 cat <<-EOF > ${licmsg}
1402 ********************************************************** 1503 **********************************************************
1403 The following license outlines the terms of use of this 1504 The following license outlines the terms of use of this
1476 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1577 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1477 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1578 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1478 export CDROM_SET=-1 1579 export CDROM_SET=-1
1479 for f in ${CDROM_CHECK_1//:/ } ; do 1580 for f in ${CDROM_CHECK_1//:/ } ; do
1480 ((++CDROM_SET)) 1581 ((++CDROM_SET))
1481 [[ -e ${CD_ROOT}/${f} ]] && break 1582 [[ -e ${CDROM_ROOT}/${f} ]] && break
1482 done 1583 done
1483 export CDROM_MATCH=${f} 1584 export CDROM_MATCH=${f}
1484 return 1585 return
1485 fi 1586 fi
1486 1587
1660 else 1761 else
1661 newls="" 1762 newls=""
1662 fi 1763 fi
1663 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do 1764 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1664 if [[ ${op} == "-i" ]] ; then 1765 if [[ ${op} == "-i" ]] ; then
1665 hasq ${f} ${ls} && newls="${newls} ${f}" 1766 has ${f} ${ls} && newls="${newls} ${f}"
1666 else 1767 else
1667 hasq ${f} ${ls} || newls="${newls} ${f}" 1768 has ${f} ${ls} || newls="${newls} ${f}"
1668 fi 1769 fi
1669 done 1770 done
1670 ls=${newls} 1771 ls=${newls}
1671 done 1772 done
1672 else 1773 else
1674 fi 1775 fi
1675 1776
1676 nols="" 1777 nols=""
1677 newls="" 1778 newls=""
1678 for f in ${LINGUAS} ; do 1779 for f in ${LINGUAS} ; do
1679 if hasq ${f} ${ls} ; then 1780 if has ${f} ${ls} ; then
1680 newls="${newls} ${f}" 1781 newls="${newls} ${f}"
1681 else 1782 else
1682 nols="${nols} ${f}" 1783 nols="${nols} ${f}"
1683 fi 1784 fi
1684 done 1785 done
1739 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1840 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1740 ewarn "in order to remove these old dependencies. If you do not have this" 1841 ewarn "in order to remove these old dependencies. If you do not have this"
1741 ewarn "helper program, simply emerge the 'gentoolkit' package." 1842 ewarn "helper program, simply emerge the 'gentoolkit' package."
1742 ewarn 1843 ewarn
1743 fi 1844 fi
1845 # temp hack for #348634 #357225
1846 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1744 ewarn " # revdep-rebuild --library ${lib##*/}" 1847 ewarn " # revdep-rebuild --library '${lib}'"
1745 done 1848 done
1746 if [[ ${notice} -eq 1 ]] ; then 1849 if [[ ${notice} -eq 1 ]] ; then
1747 ewarn 1850 ewarn
1748 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1851 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1749 ewarn "delete the old libraries. Here is a copy & paste for the lazy:" 1852 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1754} 1857}
1755 1858
1756# @FUNCTION: built_with_use 1859# @FUNCTION: built_with_use
1757# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1860# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1758# @DESCRIPTION: 1861# @DESCRIPTION:
1862#
1863# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1864#
1759# A temporary hack until portage properly supports DEPENDing on USE 1865# A temporary hack until portage properly supports DEPENDing on USE
1760# flags being enabled in packages. This will check to see if the specified 1866# flags being enabled in packages. This will check to see if the specified
1761# DEPEND atom was built with the specified list of USE flags. The 1867# DEPEND atom was built with the specified list of USE flags. The
1762# --missing option controls the behavior if called on a package that does 1868# --missing option controls the behavior if called on a package that does
1763# not actually support the defined USE flags (aka listed in IUSE). 1869# not actually support the defined USE flags (aka listed in IUSE).
1892 else 1998 else
1893 newbin "${tmpwrapper}" "${wrapper}" || die 1999 newbin "${tmpwrapper}" "${wrapper}" || die
1894 fi 2000 fi
1895} 2001}
1896 2002
1897# @FUNCTION: prepalldocs 2003# @FUNCTION: path_exists
1898# @USAGE: 2004# @USAGE: [-a|-o] <paths>
1899# @DESCRIPTION: 2005# @DESCRIPTION:
1900# Compress files in /usr/share/doc which are not already 2006# Check if the specified paths exist. Works for all types of paths
1901# compressed, excluding /usr/share/doc/${PF}/html. 2007# (files/dirs/etc...). The -a and -o flags control the requirements
1902# Uses the ecompressdir to do the compression. 2008# of the paths. They correspond to "and" and "or" logic. So the -a
1903# 2009-02-18 by betelgeuse: 2009# flag means all the paths must exist while the -o flag means at least
1904# Commented because ecompressdir is even more internal to 2010# one of the paths must exist. The default behavior is "and". If no
1905# Portage than prepalldocs (it's not even mentioned in man 5 2011# paths are specified, then the return value is "false".
1906# ebuild). Please submit a better version for review to gentoo-dev 2012path_exists() {
1907# if you want prepalldocs here. 2013 local opt=$1
1908#prepalldocs() { 2014 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1909# if [[ -n $1 ]] ; then
1910# ewarn "prepalldocs: invalid usage; takes no arguments"
1911# fi
1912 2015
1913# cd "${D}" 2016 # no paths -> return false
1914# [[ -d usr/share/doc ]] || return 0 2017 # same behavior as: [[ -e "" ]]
2018 [[ $# -eq 0 ]] && return 1
1915 2019
1916# find usr/share/doc -exec gzip {} + 2020 local p r=0
1917# ecompressdir --ignore /usr/share/doc/${PF}/html 2021 for p in "$@" ; do
1918# ecompressdir --queue /usr/share/doc 2022 [[ -e ${p} ]]
1919#} 2023 : $(( r += $? ))
2024 done
2025
2026 case ${opt} in
2027 -a) return $(( r != 0 )) ;;
2028 -o) return $(( r == $# )) ;;
2029 esac
2030}

Legend:
Removed from v.1.323  
changed lines
  Added in v.1.363

  ViewVC Help
Powered by ViewVC 1.1.20